       dist=P/2
       q=1
       proc(0,0) = n
       do i=1,d
         do j=0,q-1
           proc(i,2*j)=proc(i-1,j)
           proc(i,2*j+1)=MOD(proc(i-1,j)+dist,P)
         enddo
         q=2*q
         dist=dist/2
       enddo
